/**
  Example program to demonstrate when signal handlers are needed.
  Orion Sky Lawlor, olawlor@acm.org, 2006/02/03 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <setjmp.h>
jmp_buf backagain;

typedef void (*void_fn)(void);

volatile void_fn f=0;

void real_fn(void) {
	printf("Made it to real_fn!\n");
}

void signal_handler(int sig) { /* <- Called when a SIGSEGV occurs */
	if (f!=0) {printf("Re-entered signal handler!\n");exit(1);}
	else printf("Inside signal handler\n");
	f=real_fn;
	longjmp(backagain,1);
}

int main() {
	signal(SIGSEGV,signal_handler); /* <- Listen for signal */
	
	setjmp(backagain);
	printf("Calling function\n");
	f();
	printf("Back from function\n");
	return 0;
}
